if {0} {

	/*
		* This file is part of din.
		*
		* din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
		* For more information, please visit http://dinisnoise.org
		*
		* din is free software: you can redistribute it and/or modify
		* it under the terms of the GNU General Public License as published by
		* the Free Software Foundation, either version 2 of the License, or
		* (at your option) any later version.
		*
		* din is distributed in the hope that it will be useful, but WITHOUT
		* ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
		* FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
		* for more details.
		*
		* You should have received a copy of the GNU General Public License along
		* with din.  If not, see <http://www.gnu.org/licenses/>.
		*
	*/

}

puts -nonewline "+++ loading Tcl init script: "

namespace import ::tcl::mathop::*

;# console colors
set color(header) {set-text-color 1 0.75 0.5}
set color(text) {set-text-color 0.8 1 0.8}
set color(error) {set-text-color 1 0.6 0.6}
set color(fine) {set-text-color 0.6 1 0.6}

proc src {name} {
	source ~/.din/$name.tcl
}

proc tap-bpm-changed {name element op} {
	;# tap bpm changed
	upvar taptarget target tapbpm bpm
	echo "tap bpm: $bpm"
	set-bpm $target $bpm
}

trace add variable tapbpm write tap-bpm-changed

proc lsdotdin {{ext *} {orient h} } {
	set mapping [list .$ext {}]
	if {$orient eq "v" || $orient eq "vertical"} {lappend mapping { } \n}
	string map $mapping [lsort [glob -tails -directory ~/.din *.$ext]]
}

;# list_resonators
set lsr_body {{{orient h} {ext res}} {lsdotdin $ext $orient}}
proc ls-resonators {*}$lsr_body
proc lsr {*}$lsr_body

proc delete-disabled-resonators {} {
	save-resonators . 1
	load-resonators .
}

proc bad-sub-command {c} {
	upvar $c cmds
	set err "bad sub-command. should be: "
	foreach i [lrange $cmds 0 end-1] {
		append err "$i, "
	}
	append err "or [lindex $cmds end]"
}

proc exec-sub-command {ucmds uactions ucmd uargs} {
	upvar $ucmds cmds $uactions actions $ucmd cmd $uargs args
	set j 0
	foreach i $cmds {
		if {$cmd eq $i} {
			return [{*}[lindex $actions $j] {*}$args]
		}
		incr j
	}
	bad-sub-command cmds
}

proc find-scale {pattern} {
	lsort [lsearch -all -inline [ls-scale] $pattern]
}

proc tuning {cmd args} { ;# tuning command
	set cmds {list set get}
	set actions {"lsdotdin tuning" "sv tuning" "gv tuning"}
	exec-sub-command cmds actions cmd args
}

proc drones-deleted {args} {}

;# called once every ui loop
proc loop {} {}

source ~/.din/help.tcl
source ~/.din/midimap.tcl

puts "done. +++"
