proc getval {min max amount} { ;# get interpolated value
	set amount [/ $amount 127.0]
	return [expr { (1 - $amount) * $min + $amount * $max }]
}

proc handle_joystick {status axis value} {
	
	# for x
	set xl 4
	set xm 5
	set xr 6
	
	# for y
	set yb 1
	set ym 2
	set yt 3
	
	if {($axis eq $xl) || ($axis eq $xr) } {
		set dir [expr $axis -  $xm]
		sv fmd [expr $dir * [getval 0 1000 $value]] ;# set fm depth
		return
	}

	if {($axis eq $yb) || ($axis eq $yt) } {
		set dir [expr $axis -  $ym]
		sv amd [expr $dir * [getval 0 4 $value]] ;# set am depth
	}
	
}

proc check_apply {src val body} {
	if {$src eq $val} $body
}

proc handle_slider {status slider value} {
	check_apply $slider 8 "set_bpm gl [getval 1 480 $value]"
	check_apply $slider 10 "set_bpm gr [getval 1 480 $value]"
}


proc midi_cc {status cc value} { 
	handle_joystick $status $cc $value
	handle_slider $status $cc $value
}

proc midi_start {} {
	upvar midibpm bpm
	upvar bpm_target target
	foreach i $target "set_bpm $i $bpm reset"
	echo "MIDI clock bpm: $bpm"
}
