/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __mocap
#define __mocap

class basic_editor;

struct mocap { // mouse capture
	
	static const int MAX_POINTS = 1024;
	static const int MAX_CAP = 3 * MAX_POINTS;
	float xy [MAX_CAP];
	int npts;
	int n_3;
	
	float lx, ly;
	
	int repi, rep;
	
  int cur;
  
  int state;
  enum {empty, capturing, finished};
  
  mocap ();
  bool get (float& x, float& y);
  bool add (float wx, float wy); 
  void finish (basic_editor* b);
  void clear ();
  int operator() (); // mocap exists?
    
};

#endif
