/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __modder
#define __modder

template <class T> 

struct modder { // for modifying param

  T min, max, delta;
  
  public:
    
    modder () {
      min = max = delta = 0;
    }
    
    modder (T _min, T _max, T _delta) {
      min = _min;
      max = _max;
      delta = _delta;
    }
        
    void inc (T& param) {
      T pi = param + delta;
      if (pi > max) pi = max; 
      param = pi;
    }
    
    void dec (T& param) {
      T pi = param - delta;
      if (pi < min) pi = min; 
      param = pi;
    }
    
};

#endif
