/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __MORSE_CODE
#define __MORSE_CODE

#include "command.h"
#include "multi_curve.h"
#include "curve_editor.h"
#include "listeners.h"

struct morse_code : command { // convert text to morse code to multi_curve to use as a pattern

	int ncodes;
	map <char, string> code;

	multi_curve dot, dash, inner;
	multi_curve letter, word;

	curve_editor ed;
	morse_code_listener lis;

	int add_first_vertex;
	point<float> org;
	point<float> vi;

	morse_code (const string& ln, const string& sn);
	~morse_code ();

	bool load (const string& fname);
	bool operator() (tokenizer& tz);
	bool create_pattern (const string& text);
	void append (multi_curve& m, multi_curve& p);

};

#endif
