/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#ifndef __pool
#define __pool

template <class T> struct pool {
	T elem;
	int free;
	int next;
};
template<class T> inline int get_free1 (pool<T>* p, int n) {
	for (int i = 0; i < n; ++i) if (p[i].free) { p[i].free = 0; return i; }
	return -1;
}

template<class T> inline void free_pool (pool<T>* p, int n) {
	for (int i = 0; i < n; ++i) p[i].free = 1;
}

#endif
