/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#include "din.h"
#include "listeners.h"
#include "beat2value.h"
#include "delay.h"

strength_listener::strength_listener (din* dd) : d (dd) {}

void strength_listener::selected (int i)  {
  d->select_resonator (i);
}

void strength_listener::disabled (int i, bool state) {
  d->disable_resonator (i, state);
}

void strength_listener::edited (int i) {
  d->edit_resonator (i, resonator::STRENGTH);
}

wave_listener::wave_listener (din* dd) : d (dd) {}

void wave_listener::edited (int i) {
  d->edit_resonator (d->cur_resonator, resonator::WAVE);
}

left_listener::left_listener (din* dd) : d (dd) {}

void left_listener::edited (int i) {
  d->edit_resonator (d->cur_resonator, resonator::LEFT);
}

right_listener::right_listener (din* dd) : d (dd) {}

void right_listener::edited (int i) {
  d->edit_resonator (d->cur_resonator, resonator::RIGHT);
}

drone_listener::drone_listener (din* dd) : d (dd) {}

void drone_listener::edited (int i) {
	d->update_drone_solvers ();
}

beat2value_listener::beat2value_listener (beat2value* bv) : beat2value0 (bv) {}

void beat2value_listener::edited (int i) {
  beat2value0->curve_edited ();
}

morse_code_listener::morse_code_listener () {}
void morse_code_listener::edited (int i) {}

void delay_listener::edited (int i) {
	sol->update ();
	float dx = 1./(dly->nsamples - 1), x = -dx;
	sol->operator()(x, dx, dly->nsamples, result);
}
