/*
 * This file is part of din.
 *
 * din is copyright (c) 2006 - 2011 S Jagannathan <jag@dinisnoise.org>
 * For more information, please visit http://dinisnoise.org
 *
 * din is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 2 of the License, or
 * (at your option) any later version.
 *
 * din is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with din.  If not, see <http://www.gnu.org/licenses/>.
 *
*/
#include "range.h"
#include "font.h"
#include "utils.h"
#include "random.h"
#include <map>
using namespace std;

int range::char_height, range::ybot1, range::ybot2, range::ytop1, range::ytop2;

void range::calc_notes (int octave, float start, map<string, float>& _intervals) {

  float start_interval = _intervals [intervals[0]];
  float end_interval = _intervals [intervals[1]];
  float start_frequency = start_interval * start;
  float end_frequency = end_interval * start;
  notes[0].set_frequency (start_frequency);
  notes[0].octave_position = octave + start_interval - 1;
  notes[1].set_frequency (end_frequency);
  notes[1].octave_position = octave + end_interval - 1;
  delta_step = notes[1].step - notes[0].step;
  delta_octave_position = notes[1].octave_position - notes[0].octave_position;
}

void range::draw_labels (int label_what, int show_frequency) {

  // mark and label intervals
  glColor3f (1, 1, 1);
	glBegin (GL_LINES);
		glVertex2i (extents.left, extents.bottom);
		glVertex2i (extents.left, extents.top);
	glEnd ();
  draw_string (labels[0], extents.left, ytop1);
  draw_string (labels[0], extents.left, ybot1);
  if (show_frequency) {
		glColor3f (0.5, 0.5, 0.5);
		draw_string (labels[2], extents.left, ybot2);
		draw_string (labels[2], extents.left, ytop2);
	}
  if (label_what == BOTH) {
    glColor3f (1, 1, 1);
    glBegin (GL_LINES);
      glVertex2i (extents.right, extents.bottom);
      glVertex2i (extents.right, extents.top);
    glEnd ();
    draw_string (labels[1], extents.right, ybot1);
    draw_string (labels[1], extents.right, ytop1);
    if (show_frequency) {
			glColor3f (0.5, 0.5, 0.5);
			draw_string (labels[3], extents.right, ybot2);
			draw_string (labels[3], extents.right, ytop2);
		}
  }
}
